unit bobs;

INTERFACE

procedure go;

IMPLEMENTATION

uses main,Mode13,colors,vector,keys,MyDOS,MyMidas,math;

const
	TOTAL=2000;

	ALTO=6;ANCHO=round(ALTO*FIX_ASPECT_RATIO);

type
	Tbobs=record
		x,y,z:integer;
	end;
	TaBobs=array[0..TOTAL] of Tbobs;

var
	b:^TaBobs;

	IncAlto:byte;
	IncAncho1,IncAncho2,
	IncY1:word;

procedure PutBobClipped(x,y:integer);ASSEMBLER;
ASM
	PUSH		DS
	PUSH		BP

	MOV			AX,DS
	MOV			ES,AX

	MOV			IncAlto,0
	MOV			IncY1,0
	MOV			IncAncho1,0
	MOV			IncAncho2,0

	MOV			DX,region.xul
	MOV			CX,x
	MOV			AX,CX
	ADD			AX,ANCHO
	CMP			AX,DX						{if x+ancho<region.xul then goto fin}
	JBE			@SALIR

	CMP			CX,DX   				{if x<region.xul then...}
	JAE			@SIGUE_X1

	MOV			AX,DX           {x:=region.xul;}
	SUB			AX,CX
	MOV			IncAncho1,AX    {...dec(ancho,abs(region.xul-x);}

	MOV			CX,DX						{CX=x=region.xul}
	JMP			@SIGUE_X2

@SIGUE_X1:
	MOV			DX,region.xlr
	CMP			CX,DX   				{if x>region.xlr then goto fin}
	JG			@SALIR

	CMP			AX,DX   				{if x+ancho>region.xlr then...}
	JLE			@SIGUE_X2
	SUB			AX,DX
	MOV			IncAncho2,AX   	{dec(ancho,(x+ancho)-region.xlr}

@SIGUE_X2:
	MOV			DX,region.yul
	MOV			BX,y
	MOV			AX,BX
	ADD			AX,ALTO
	CMP			AX,DX						{if y+alto<region.yul then goto fin}
	JL			@SALIR

	CMP			BX,DX   				{if y<region.yul then...}
	JGE			@SIGUE_Y1
	MOV			AX,DX           {y:=region.yul;}
	SUB			AX,BX
	MOV			IncAlto,AL      {...dec(alto,abs(region.yul-y);}

	SHL			AX,5  {}          {...inc(IncY1,abs(region.yul-y)*ancho);}
	MOV			IncY1,AX
	MOV			BX,region.yul		{...y:=region.yul}

@SIGUE_Y1:
	MOV			DX,region.ylr
	CMP			BX,DX   				{if y>region.ylr then goto fin}
	JG			@SALIR

	MOV			AX,BX
	ADD			AX,ALTO
	CMP			AX,DX   				{if y+alto>region.ylr then...}
	JLE			@SIGUE_Y2
	SUB			AX,DX
	MOV			IncAlto,AL  		{dec(alto,(y+alto)-region.ylr}
	JMP			@SIGUE_Y2

@SIGUE_Y2:      {BX=y, CX=x}
	MOV			AL,ALTO
	SUB			AL,IncAlto

	ADD			BX,BX
	MOV			DI,CX
	ADD			DI,WORD(MultBy320[BX])

	MOV			BX,ANCHO
	SUB			BX,IncAncho1
	SUB			BX,IncAncho2
	MOV			BP,320
	SUB			BP,BX

	MOV			DS,vRAM
	ADD			SI,ES:IncY1

@Y:
	MOV			CX,BX
	ADD			SI,ES:IncAncho1

@X:
	INC			BYTE([DI])
	INC			DI
	DEC			CX
	JNZ			@X

	ADD			SI,ES:IncAncho2
	ADD			DI,BP
	DEC			AX
	JNZ     @Y

@SALIR:
	POP			BP
	POP			DS
END;

procedure InitBobs;
var
	n:integer;

begin
	for n:=0 to TOTAL do with b^[n] do
		begin
			x:=500+(n*2*sine[n mod DEG]) div ESCALE;
			y:=415+(n*sine[COSINE+(n mod DEG)]) div ESCALE;
			z:=round(n*secante(n));
		end;

	for n:=1 to 255 do shade[n]:=n-1;
end;

procedure go;
var
	p:Tpal;
	v:Pobject;
	bb:^Tbobs;
	a,d,n,s:integer;

begin
	StartCrono;
	ClearVideo;
	SetTransferMode(FLAME{HALF_DIFUMINE});

	if not LoadPal(p,'BOBS.RGB') then error('BOBS.RGB');
	p[255]:=p[0];
	InkAllRGB(0,255,p);

	new(b);
	InitBobs;

	new(v);
	ResetObject(v);

	SkipFrames:=StartFrame;
	a:=0;
	main.i:=FALSE;
	repeat
		s:=GetSemaphore(15);
		if (s=FLASH) or (s=FADE) then
			blanking
		else
			if not main.i then InkAllRGB(0,255,p);

		Precalc6Mult(v);

		bb:=@b^[0];
		for n:=0 to TOTAL do
			begin
				with bb^ do
					begin
						v^.x:=x;v^.y:=y;v^.z:=z;
					end;
				inc(bb);
				RotateVertex6Mult(v);

				with v^ do PutBobClipped(sx,sy);
			end;

		for d:=1 to SkipFrames do
			begin
				with v^ do
					begin
						inc(balanza);
						if balanza>DEG then balanza:=0;

						dec(deriva,2);
						if deriva<0 then inc(deriva,DEG);

						inc(caida,2);
						if caida>DEG then dec(caida,DEG);
					end;

				inc(a);
				if (a=600) and not (main.i) then
					begin
						InitDifumine(0,255,WhitePal);
						main.i:=TRUE;
					end;
			end;

		if inkey[K_ESC] then halt;

		if (main.i) and (main.difumine) then break;

		SkipFrames:=anima;
	until StopCrono>times[main.BOBS];
	{$IFDEF _DEBUG_}
	WriteLn(fich,'BOBS: ',StopCrono);
	{$ENDIF}

	dispose(v);
	dispose(b);
end;

end.